var fs = require('fs'),
    jhttp = require('json-http');

function json2file(json, fileName){
  fs.writeFile(fileName, json2FileString(json), function (err) {
    if (err) throw err;
  });
}

function json2FileString(json){
  let arr = [].concat(json);
  const props = Object.getOwnPropertyNames(response[0]);
  let result = props.join(';') + '\n';

  response.forEach(function(item){
    props.forEach(function (propName){
       result += item[propName] + ';';
      });
    result += '\n';
  });


  return result;
}

function jsonHttp2String(url, cb){
  return jhttp.getJson(url ,function(err, res){
       if (err) throw err;

       return cb(json2FileString(res));
  });

}

function jsonHttp2File(url, fileName, cb){
  jsonHttp2String(url, function(res){
    const __onFileWrite__ = cb || function (err) {
        if (err) throw err;
    };
    fs.writeFile(fileName, res, __onFileWrite__);
  });
}

const json2csv = {
  json2file,
  json2FileString,
  jsonHttp2File,
  jsonHttp2String
};

if(module.parent) {
    module.exports = json2csv;
} else {
    const args = process.argv.slice(2);
    const url = args[0];
    const file = args[1] || 'result.csv';

    json2FileString(url, file);
}
